ig.module(
	'plugins.dc.font'
)
.requires(
	'impact.font'
)
.defines(function(){


ig.Font.inject({
/*
	load: function( loadCallback ) {
		console.log('in overridden font.load');
		if( this.loaded ) {
			if( loadCallback ) {
				loadCallback( this.path, true );
			}
			return;
		}
		else if( !this.loaded && ig.ready ) {
			this.loadCallback = loadCallback || null;
			//need to fix for android
			//this.data = new _native.Font( this.path, this.onload.bind(this) );
			this.onload();//hack
		}
		else {
			ig.addResource( this );
		}
		ig.Image.cache[this.path] = this;
	},

	onload: function( width, height ) {
		this.width = width;
		this.height = height;
		this.loaded = true;
		
		if( this.loadCallback ) {
			this.loadCallback( this.path, true );
			console.log('called loadCallback');
			
		}
	},

	draw: function( text, x, y, align ) {
		if( !this.loaded ) { return; }
		ig.system.context.drawFont(this.data,text.toString(),x,y,(align||0));
	}
*/
	_loadMetrics: function( image ) {
		// Draw the bottommost line of this font image into an offscreen canvas
		// and analyze it pixel by pixel.
		// A run of non-transparent pixels represents a character and its width
		
		this.height = image.height-1;
		this.widthMap = [];
		this.indices = [];
		
		var canvas = ig.$new('canvas');
		//console.log(canvas.id);
		var ctx = canvas.getContext('2d');
		//console.log( image.width);
		ctx.width = image.width;
		//console.log( image.height);
		ctx.height = image.height;
		ctx.drawImage( image, 0, 0 );
		var px = ctx.getImageData(0, image.height-1, image.width, 1);
		
		var currentChar = 0;
		var currentWidth = 0;
		for( var x = 0; x < image.width; x++ ) {
			var index = x * 4 + 3; // alpha component of this pixel
			var alpha = px.data[index];
			if( alpha != 0 ) {
				currentWidth++;
			}
			else if( alpha == 0 && currentWidth ) {
				this.widthMap.push( currentWidth );
				this.indices.push( x-currentWidth );
				currentChar++;
				currentWidth = 0;
			}
		}
		this.widthMap.push( currentWidth );
		this.indices.push( x-currentWidth );
		//console.log('widthMap:'+this.widthMap+' indices:'+this.indices);
	}
});


});